using LinearAlgebra

function arnoldi_factorization(A,v,m)
    n = size(A,1);
    v = v/norm(v);

    Q = zeros(n,m+1); Q[:,1] = v;
    H = zeros(m+1,m);

    for k=1:m
        z = A*Q[:,k];
        for j=1:k
            H[j,k] = Q[:,j]'*z;
            z = z - H[j,k]*Q[:,j];
        end
        H[k+1,k] = norm(z);
        if H[k+1,k] == 0
            println("error: H[k+1,k] = 0")
            break;
        end
        Q[:,k+1] = z/H[k+1,k];
    end
    return Q, H
end

A = randn(7,7);
v = ones(7);
m = 3;

Q, H = arnoldi_factorization(A,v,m)
